---
title: One-Click Survey Localization Using AI
product: Survey Creator
description: Discover how to integrate AI-driven translation into Survey Creator for seamless localization. Instantly translate your surveys and forms into multiple languages with AI and preview translations in real time. View this JavaScript form builder demo to learn more.
framework: Vanilla JS
source: https://surveyjs.io/survey-creator/examples/ai-translation/vanillajs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# One-Click Survey Localization Using AI (Vanilla JS)

AI-powered translation services can help you localize your surveys. This example shows how to integrate AI localization into Survey Creator. Click the Localize Survey button to automatically translate English texts to a number of predefined languages. Change the survey language using the **Select a survey language** dropdown in the Property Grid to view the translations on the design surface.

## Specify Target Languages

Survey texts can be translated to one or more languages. Define an array of target locales and assign it to the `supportedLocales` property of the `surveyLocalization` object. In this demo, the `supportedLocales` array contains four languages: Spanish, French, Italian, and German. The default language&mdash;English&mdash;is used as a source for translations.

## Enable Machine Translation

To integrate machine translation into Survey Creator, you need to deploy a language model to your application and expose an API for interaction with that model. Refer to tutorials dedicated to the model of your choice for instructions. This example uses the GPT-3.5 Turbo model deployed on the SurveyJS website.

A deployed AI model receives original survey texts and responds with their translations. To submit the survey texts, handle the [`onMachineTranslate`](/survey-creator/documentation/api-reference/survey-creator#onMachineTranslate) event. Use its `options.fromLocale`, `options.toLocale`, and `options.strings` parameters to identify the source and target languages and access the strings to translate. After the AI service returns an array with translations, pass it to the `options.callback` method.

The `options.strings` array contains only the strings that are empty in the target language. Once they are filled in, those strings won't be updated if a string in a source language is modified. To ensure that automatic translations are up-to-date, enable the [`clearTranslationsOnSourceTextChange`](/survey-creator/documentation/api-reference/icreatoroptions#clearTranslationsOnSourceTextChange) property in the Survey Creator configuration object. With this setting, translations to other languages will be cleared and ready to be localized again after a change in their source string.

To trigger AI translation in code, call Survey Creator's [`startMachineTranslationTo(locales)`](/survey-creator/documentation/api-reference/survey-creator#startMachineTranslationTo) method, passing an array of target locale codes to it. This method causes the `onMachineTranslate` event to raise and perform AI translation. You can call this method using any UI element that suits the design of your application most. This demo shows how to add a custom action button to the toolbar for this purpose. Refer to the Code tab for a code example.

If you want to select target languages and edit translations in a specially designed UI, enable the Translations tab in Survey Creator. Refer to the following example for more information:

[Create a Multilingual Form](/survey-creator/examples/create-multilingual-forms/reactjs (linkStyle))

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/survey_json.js`

```js
export const surveyJSON = {
    "pages": [{
        "name": "page1",
        "elements": [{
            "type": "matrix",
            "name": "qualities",
            "title": "Please indicate if you agree or disagree with the following statements",
            "columns": [{
                "value": 5,
                "text": "Strongly agree"
            }, {
                "value": 4,
                "text": "Agree"
            }, {
                "value": 3,
                "text": "Neutral"
            }, {
                "value": 2,
                "text": "Disagree"
            }, {
                "value": 1,
                "text": "Strongly disagree"
            }],
            "rows": [{
                "value": "affordable",
                "text": "Product is affordable"
            }, {
                "value": "does-what-it-claims",
                "text": "Product does what it claims"
            }, {
                "value": "better-than-others",
                "text": "Product is better than other products on the market"
            }, {
                "value": "easy-to-use",
                "text": "Product is easy to use"
            }]
        }]
    }, {
        "name": "page2",
        "elements": [{
            "type": "rating",
            "name": "satisfaction-score",
            "title": "How satisfied are you with our product?",
            "minRateDescription": "Not satisfied",
            "maxRateDescription": "Completely satisfied"
        }, {
            "type": "comment",
            "name": "suggestions",
            "title": "What would make you more satisfied with our product?",
            "maxLength": 300
        }]
    }, {
        "name": "page3",
        "elements": [{
            "type": "radiogroup",
            "name": "price-comparison",
            "title": "Compared to our competitors, do you feel our product is:",
            "choices": [
                "Less expensive",
                "Priced about the same",
                "More expensive",
                "Not sure"
            ]
        }]
    }, {
        "name": "page4",
        "elements": [{
            "type": "text",
            "name": "email",
            "title": "Thank you for taking our survey. Please leave your email address if you would like us to contact you."
        }]
    }]
};
```

### `src/index.js`

```js
import { SurveyCreator } from "survey-creator-js";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { surveyLocalization, Action, ComputedUpdater } from "survey-core";
import { surveyJSON } from "./survey_json";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";
import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

const creator = new SurveyCreator({ clearTranslationsOnSourceTextChange: true });

const supportedLocales = ["es", "fr", "it", "de"];
surveyLocalization.supportedLocales = supportedLocales;

// Configure a custom action button
const localizeSurveyAction = new Action({
    id: "localize-survey",
    title: "Localize Survey",
    iconName: "icon-language",
    // Uncomment the following line to display only the icon
    // showTitle: false,
    visible: new ComputedUpdater(() => creator.activeTab === "designer"),
    action: () => {
        creator.startMachineTranslationTo(supportedLocales); // Raises the `onMachineTranslate` event
    }
});

// Add the button to the toolbar
creator.toolbar.actions.push(localizeSurveyAction);

// Add a custom button to the bottom toolbar (visible only on mobile devices)
creator.footerToolbar.actions.push(localizeSurveyAction);

// Translate strings using AI
creator.onMachineTranslate.add((_, options) => {
    const url = window.location.origin + "/api/StringsTranslator/translate";
    try {
        fetch(url, {
            method: "POST",
            headers: {
                "Content-Type": "application/json;charset=UTF-8",
            },
            body: JSON.stringify({ "fromLocale": options.fromLocale, "toLocale": options.toLocale, "strings": options.strings })
        })
        .then(response => response.json())
        .then(data => {
            options.callback(data);
            const str = data.length + " strings are translated";
            creator.notify(str);
        });
    } catch (error) {
        options.callback();
        console.error("AI translation API is unavailable");
    }
});

creator.JSON = surveyJSON;
creator.render("surveyCreatorContainer");
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-js": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/ai-translation/angular.md)
- [React](https://surveyjs.io/survey-creator/examples/ai-translation/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/ai-translation/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/ai-translation/jquery.md)


---
title: One-Click Survey Localization Using AI
product: Survey Creator
description: Discover how to integrate AI-driven translation into Survey Creator for seamless localization. Instantly translate your surveys and forms into multiple languages with AI and preview translations in real time. View this JavaScript form builder demo to learn more.
framework: Angular
source: https://surveyjs.io/survey-creator/examples/ai-translation/angular
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# One-Click Survey Localization Using AI (Angular)

AI-powered translation services can help you localize your surveys. This example shows how to integrate AI localization into Survey Creator. Click the Localize Survey button to automatically translate English texts to a number of predefined languages. Change the survey language using the **Select a survey language** dropdown in the Property Grid to view the translations on the design surface.

## Specify Target Languages

Survey texts can be translated to one or more languages. Define an array of target locales and assign it to the `supportedLocales` property of the `surveyLocalization` object. In this demo, the `supportedLocales` array contains four languages: Spanish, French, Italian, and German. The default language&mdash;English&mdash;is used as a source for translations.

## Enable Machine Translation

To integrate machine translation into Survey Creator, you need to deploy a language model to your application and expose an API for interaction with that model. Refer to tutorials dedicated to the model of your choice for instructions. This example uses the GPT-3.5 Turbo model deployed on the SurveyJS website.

A deployed AI model receives original survey texts and responds with their translations. To submit the survey texts, handle the [`onMachineTranslate`](/survey-creator/documentation/api-reference/survey-creator#onMachineTranslate) event. Use its `options.fromLocale`, `options.toLocale`, and `options.strings` parameters to identify the source and target languages and access the strings to translate. After the AI service returns an array with translations, pass it to the `options.callback` method.

The `options.strings` array contains only the strings that are empty in the target language. Once they are filled in, those strings won't be updated if a string in a source language is modified. To ensure that automatic translations are up-to-date, enable the [`clearTranslationsOnSourceTextChange`](/survey-creator/documentation/api-reference/icreatoroptions#clearTranslationsOnSourceTextChange) property in the Survey Creator configuration object. With this setting, translations to other languages will be cleared and ready to be localized again after a change in their source string.

To trigger AI translation in code, call Survey Creator's [`startMachineTranslationTo(locales)`](/survey-creator/documentation/api-reference/survey-creator#startMachineTranslationTo) method, passing an array of target locale codes to it. This method causes the `onMachineTranslate` event to raise and perform AI translation. You can call this method using any UI element that suits the design of your application most. This demo shows how to add a custom action button to the toolbar for this purpose. Refer to the Code tab for a code example.

If you want to select target languages and edit translations in a specially designed UI, enable the Translations tab in Survey Creator. Refer to the following example for more information:

[Create a Multilingual Form](/survey-creator/examples/create-multilingual-forms/reactjs (linkStyle))

## Files

### `src/app/components/creator.component.css`

```css
/* You can define custom CSS rules here */
```

### `src/app/components/creator.component.html`

```html
<div style="position: fixed; top: 0; bottom: 0; right: 0; left: 0;">
    <survey-creator [model]="model"></survey-creator>
</div>
```

### `src/app/components/survey_json.js`

```js
export const surveyJSON = {
    "pages": [{
        "name": "page1",
        "elements": [{
            "type": "matrix",
            "name": "qualities",
            "title": "Please indicate if you agree or disagree with the following statements",
            "columns": [{
                "value": 5,
                "text": "Strongly agree"
            }, {
                "value": 4,
                "text": "Agree"
            }, {
                "value": 3,
                "text": "Neutral"
            }, {
                "value": 2,
                "text": "Disagree"
            }, {
                "value": 1,
                "text": "Strongly disagree"
            }],
            "rows": [{
                "value": "affordable",
                "text": "Product is affordable"
            }, {
                "value": "does-what-it-claims",
                "text": "Product does what it claims"
            }, {
                "value": "better-than-others",
                "text": "Product is better than other products on the market"
            }, {
                "value": "easy-to-use",
                "text": "Product is easy to use"
            }]
        }]
    }, {
        "name": "page2",
        "elements": [{
            "type": "rating",
            "name": "satisfaction-score",
            "title": "How satisfied are you with our product?",
            "minRateDescription": "Not satisfied",
            "maxRateDescription": "Completely satisfied"
        }, {
            "type": "comment",
            "name": "suggestions",
            "title": "What would make you more satisfied with our product?",
            "maxLength": 300
        }]
    }, {
        "name": "page3",
        "elements": [{
            "type": "radiogroup",
            "name": "price-comparison",
            "title": "Compared to our competitors, do you feel our product is:",
            "choices": [
                "Less expensive",
                "Priced about the same",
                "More expensive",
                "Not sure"
            ]
        }]
    }, {
        "name": "page4",
        "elements": [{
            "type": "text",
            "name": "email",
            "title": "Thank you for taking our survey. Please leave your email address if you would like us to contact you."
        }]
    }]
};
```

### `src/app/components/creator.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { SurveyCreatorModel } from "survey-creator-core";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { surveyLocalization, Action, ComputedUpdater } from "survey-core";
import { surveyJSON } from "./survey_json";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey-creator",
    templateUrl: "./creator.component.html",
    styleUrls: ["./creator.component.css"]
})
export class SurveyCreatorComponent implements OnInit {
    model: SurveyCreatorModel;
    ngOnInit() {
        const creator = new SurveyCreatorModel({ clearTranslationsOnSourceTextChange: true });
        const supportedLocales = ["es", "fr", "it", "de"];
        surveyLocalization.supportedLocales = supportedLocales;
        
        // Configure a custom action button
        const localizeSurveyAction = new Action({
            id: "localize-survey",
            title: "Localize Survey",
            iconName: "icon-language",
            // Uncomment the following line to display only the icon
            // showTitle: false,
            visible: new ComputedUpdater(() => creator.activeTab === "designer"),
            action: () => {
                creator.startMachineTranslationTo(supportedLocales); // Raises the `onMachineTranslate` event
            }
        });
        
        // Add the button to the toolbar
        creator.toolbar.actions.push(localizeSurveyAction);
        
        // Add a custom button to the bottom toolbar (visible only on mobile devices)
        creator.footerToolbar.actions.push(localizeSurveyAction);
        
        // Translate strings using AI
        creator.onMachineTranslate.add((_, options) => {
            const url = window.location.origin + "/api/StringsTranslator/translate";
            try {
                fetch(url, {
                    method: "POST",
                    headers: {
                        "Content-Type": "application/json;charset=UTF-8",
                    },
                    body: JSON.stringify({ "fromLocale": options.fromLocale, "toLocale": options.toLocale, "strings": options.strings })
                })
                .then(response => response.json())
                .then(data => {
                    options.callback(data);
                    const str = data.length + " strings are translated";
                    creator.notify(str);
                });
            } catch (error) {
                options.callback();
                console.error("AI translation API is unavailable");
            }
        });
        
        creator.JSON = surveyJSON;
        this.model = creator;
    }
}
```

### `src/app/app.component.html`

```html
<component-survey-creator></component-survey-creator>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html"
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { AppComponent } from "./app.component";
import { SurveyCreatorModule } from "survey-creator-angular";
import { SurveyCreatorComponent } from "./components/creator.component";

@NgModule({
    declarations: [AppComponent, SurveyCreatorComponent],
    imports: [BrowserModule, SurveyCreatorModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add global styles to this file and import other style files */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css"  ],
      "scripts": [  ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-angular-ui": "latest",
    "survey-creator-core": "latest",
    "survey-core": "latest",
    "survey-creator-angular": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular-devkit/build-angular": "~13.0.0",
    "@angular/cli": "~13.0.0",
    "@types/jasmine": "3.6.3",
    "@types/jasminewd2": "2.0.8",
    "@types/node": "14.14.28",
    "codelyzer": "6.0.1",
    "jasmine-core": "3.6.0",
    "jasmine-spec-reporter": "6.0.0",
    "karma": "6.1.1",
    "karma-chrome-launcher": "3.1.0",
    "karma-coverage-istanbul-reporter": "3.0.3",
    "karma-jasmine": "4.0.1",
    "karma-jasmine-html-reporter": "1.5.4",
    "protractor": "7.0.0",
    "ts-node": "9.1.1",
    "tslint": "~6.1.3",
    "typescript": "4.1.5"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/survey-creator/examples/ai-translation/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/ai-translation/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/ai-translation/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/ai-translation/vanillajs.md)


---
title: One-Click Survey Localization Using AI
product: Survey Creator
description: Discover how to integrate AI-driven translation into Survey Creator for seamless localization. Instantly translate your surveys and forms into multiple languages with AI and preview translations in real time. View this JavaScript form builder demo to learn more.
framework: React
source: https://surveyjs.io/survey-creator/examples/ai-translation/reactjs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# One-Click Survey Localization Using AI (React)

AI-powered translation services can help you localize your surveys. This example shows how to integrate AI localization into Survey Creator. Click the Localize Survey button to automatically translate English texts to a number of predefined languages. Change the survey language using the **Select a survey language** dropdown in the Property Grid to view the translations on the design surface.

## Specify Target Languages

Survey texts can be translated to one or more languages. Define an array of target locales and assign it to the `supportedLocales` property of the `surveyLocalization` object. In this demo, the `supportedLocales` array contains four languages: Spanish, French, Italian, and German. The default language&mdash;English&mdash;is used as a source for translations.

## Enable Machine Translation

To integrate machine translation into Survey Creator, you need to deploy a language model to your application and expose an API for interaction with that model. Refer to tutorials dedicated to the model of your choice for instructions. This example uses the GPT-3.5 Turbo model deployed on the SurveyJS website.

A deployed AI model receives original survey texts and responds with their translations. To submit the survey texts, handle the [`onMachineTranslate`](/survey-creator/documentation/api-reference/survey-creator#onMachineTranslate) event. Use its `options.fromLocale`, `options.toLocale`, and `options.strings` parameters to identify the source and target languages and access the strings to translate. After the AI service returns an array with translations, pass it to the `options.callback` method.

The `options.strings` array contains only the strings that are empty in the target language. Once they are filled in, those strings won't be updated if a string in a source language is modified. To ensure that automatic translations are up-to-date, enable the [`clearTranslationsOnSourceTextChange`](/survey-creator/documentation/api-reference/icreatoroptions#clearTranslationsOnSourceTextChange) property in the Survey Creator configuration object. With this setting, translations to other languages will be cleared and ready to be localized again after a change in their source string.

To trigger AI translation in code, call Survey Creator's [`startMachineTranslationTo(locales)`](/survey-creator/documentation/api-reference/survey-creator#startMachineTranslationTo) method, passing an array of target locale codes to it. This method causes the `onMachineTranslate` event to raise and perform AI translation. You can call this method using any UI element that suits the design of your application most. This demo shows how to add a custom action button to the toolbar for this purpose. Refer to the Code tab for a code example.

If you want to select target languages and edit translations in a specially designed UI, enable the Translations tab in Survey Creator. Refer to the following example for more information:

[Create a Multilingual Form](/survey-creator/examples/create-multilingual-forms/reactjs (linkStyle))

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/survey_json.js`

```js
export const surveyJSON = {
    "pages": [{
        "name": "page1",
        "elements": [{
            "type": "matrix",
            "name": "qualities",
            "title": "Please indicate if you agree or disagree with the following statements",
            "columns": [{
                "value": 5,
                "text": "Strongly agree"
            }, {
                "value": 4,
                "text": "Agree"
            }, {
                "value": 3,
                "text": "Neutral"
            }, {
                "value": 2,
                "text": "Disagree"
            }, {
                "value": 1,
                "text": "Strongly disagree"
            }],
            "rows": [{
                "value": "affordable",
                "text": "Product is affordable"
            }, {
                "value": "does-what-it-claims",
                "text": "Product does what it claims"
            }, {
                "value": "better-than-others",
                "text": "Product is better than other products on the market"
            }, {
                "value": "easy-to-use",
                "text": "Product is easy to use"
            }]
        }]
    }, {
        "name": "page2",
        "elements": [{
            "type": "rating",
            "name": "satisfaction-score",
            "title": "How satisfied are you with our product?",
            "minRateDescription": "Not satisfied",
            "maxRateDescription": "Completely satisfied"
        }, {
            "type": "comment",
            "name": "suggestions",
            "title": "What would make you more satisfied with our product?",
            "maxLength": 300
        }]
    }, {
        "name": "page3",
        "elements": [{
            "type": "radiogroup",
            "name": "price-comparison",
            "title": "Compared to our competitors, do you feel our product is:",
            "choices": [
                "Less expensive",
                "Priced about the same",
                "More expensive",
                "Not sure"
            ]
        }]
    }, {
        "name": "page4",
        "elements": [{
            "type": "text",
            "name": "email",
            "title": "Thank you for taking our survey. Please leave your email address if you would like us to contact you."
        }]
    }]
};
```

### `src/SurveyCreatorComponent.jsx`

```js
import React from "react";
import { SurveyCreator, SurveyCreatorComponent } from "survey-creator-react";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { surveyLocalization, Action, ComputedUpdater } from "survey-core";
import { surveyJSON } from "./survey_json";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

function SurveyCreatorRenderComponent() {
    const creator = new SurveyCreator({ clearTranslationsOnSourceTextChange: true });
    const supportedLocales = ["es", "fr", "it", "de"];
    surveyLocalization.supportedLocales = supportedLocales;
    
    // Configure a custom action button
    const localizeSurveyAction = new Action({
        id: "localize-survey",
        title: "Localize Survey",
        iconName: "icon-language",
        // Uncomment the following line to display only the icon
        // showTitle: false,
        visible: new ComputedUpdater(() => creator.activeTab === "designer"),
        action: () => {
            creator.startMachineTranslationTo(supportedLocales); // Raises the `onMachineTranslate` event
        }
    });
    
    // Add the button to the toolbar
    creator.toolbar.actions.push(localizeSurveyAction);
    
    // Add a custom button to the bottom toolbar (visible only on mobile devices)
    creator.footerToolbar.actions.push(localizeSurveyAction);
    
    // Translate strings using AI
    creator.onMachineTranslate.add((_, options) => {
        const url = window.location.origin + "/api/StringsTranslator/translate";
        try {
            fetch(url, {
                method: "POST",
                headers: {
                    "Content-Type": "application/json;charset=UTF-8",
                },
                body: JSON.stringify({ "fromLocale": options.fromLocale, "toLocale": options.toLocale, "strings": options.strings })
            })
            .then(response => response.json())
            .then(data => {
                options.callback(data);
                const str = data.length + " strings are translated";
                creator.notify(str);
            });
        } catch (error) {
            options.callback();
            console.error("AI translation API is unavailable");
        }
    });
    
    creator.JSON = surveyJSON;
    return (<SurveyCreatorComponent creator={creator} />);
}

export default SurveyCreatorRenderComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyCreatorRenderComponent from "./SurveyCreatorComponent";

const root = createRoot(document.getElementById("surveyCreatorContainer"));
root.render(<SurveyCreatorRenderComponent />);
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-react": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/ai-translation/angular.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/ai-translation/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/ai-translation/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/ai-translation/vanillajs.md)
